﻿@using DevExpress.Web;
@using DevExpress.Web.Mvc;
@using System.Web.UI.WebControls;
@using Portal.Controllers;
@using Portal.Models.Globals;
@using Portal.Models.SupplierPerformance;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.Credential;

@Html.DevExpress().GridView(
    Grv => {
        Grv.Name = "GridSPSafety";
        Grv.KeyFieldName = " PROD_MONTH; SUPPLIER_CD";
        Grv.CallbackRouteValues = new { Controller = "SupplierPerformance", Action = "ReloadGridSPSafety" };
        Grv.ClientSideEvents.BeginCallback = "OnBeginCallback";
        Grv.ClientSideEvents.EndCallback = "OnEndCallback";
        Grv.Width = System.Web.UI.WebControls.Unit.Percentage(100);
        Grv.Styles.Header.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        Grv.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;        
        Grv.SettingsBehavior.AllowDragDrop = false;

        Grv.SettingsEditing.Mode = GridViewEditingMode.Inline;

        Grv.SettingsPager.PageSizeItemSettings.Visible = true;
        Grv.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
        Grv.SettingsPager.PageSizeItemSettings.Caption = "Page Size";

        Grv.CommandColumn.Visible = true;
        Grv.CommandColumn.ClearFilterButton.Visible = true;
        Grv.CommandColumn.ShowSelectCheckbox = true;
        Grv.CommandColumn.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        Grv.CommandColumn.ShowSelectCheckbox = true;
        Grv.CommandColumn.Width = Unit.Pixel(42);
        Grv.CommandColumn.SetHeaderTemplateContent(
            c =>
            {
                Html.DevExpress().CheckBox(
                        chckBox =>
                        {
                            chckBox.Name = "ChkBoxSafety";
                            chckBox.Properties.ClientSideEvents.CheckedChanged = "OnCheckAll";
                        }
                    ).Render();
            });

        Grv.Columns.Add(
            col => {
                col.Name = "ProductionMonth";
                col.Caption = "Production<br>Month";
                col.FieldName = "PROD_MONTH";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdSuppCode = col.PropertiesEdit as ComboBoxProperties;
                cmdSuppCode.DropDownStyle = DropDownStyle.DropDown;
                List<SPMonthYear> pm = Model.GetModel<List<SPMonthYear>>();
                if (pm.Count() > 0)
                    pm.ForEach(s => cmdSuppCode.Items.Add(s.MonthYear));  
                
                col.SetDataItemTemplateContent(container =>
                {
                    Html.DevExpress().HyperLink(hLink =>
                    {
                        hLink.Name = string.Format("hLink_1{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                        hLink.NavigateUrl = "javascript:void(0)";
                        hLink.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
                        hLink.Properties.ClientSideEvents.Click =
                                string.Format("function(s, e) {{ OnHyperLinkClick('{0}'); }}", (container as GridViewDataItemTemplateContainer).KeyValue);
                    }).Render();
                });
            });

        Grv.Columns.Add(
            col => {
                col.Name = "SupplierCode";
                col.Caption = "Supplier<br>Code";
                col.FieldName = "SUPPLIER_CD";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);

                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdSuppCode = col.PropertiesEdit as ComboBoxProperties;
                cmdSuppCode.DropDownStyle = DropDownStyle.DropDown;
                List<SupplierICS> Supplier = Model.GetModel<List<SupplierICS>>();
                if (Supplier.Count() > 0)
                    Supplier.ForEach(s => cmdSuppCode.Items.Add(s.SUPP_CD));
            });
        
        Grv.Columns.Add(
            col => {
                col.Name = "SupplierName";
                col.Caption = "Supplier Name";
                col.FieldName = "SUPPLIER_NAME";
                col.Width = Unit.Pixel(180);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "QtyFatal";
                col.Caption = "Fatal";
                col.FieldName = "QTY_FATAL";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(60);
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });

        Grv.Columns.Add(
            col => {
                col.Name = "QtyDisability";
                col.Caption = "Disability";
                col.FieldName = "QTY_DISABILITY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(60);
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });

        Grv.Columns.Add(
            col => {
                col.Name = "QtyLostOrgan";
                col.Caption = "Lost<br>Organ";
                col.FieldName = "QTY_LOST_ORGAN";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(60);
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "QtyAbsent";
                col.Caption = "Absent";
                col.FieldName = "QTY_ABSENT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(60);
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "QtyAbsentPeriod";
                col.Caption = "Absent<br>(Days)";
                col.FieldName = "QTY_ABSENT_PERIOD";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(60);
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "QtySmallInjured";
                col.Caption = "Smart<br>Injured";
                col.FieldName = "QTY_SMALL_INJURED";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(60);
                col.PropertiesEdit.DisplayFormatString = "##,##";
                
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "QtyTotalWorkers";
                col.Caption = "Total Workers<br>Man Hours";
                col.FieldName = "QTY_TOTAL_WORKERS_MH";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(80);
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });
        
        Grv.Columns.Add(
            col =>
            {
                col.Name = "Judgement";
                col.Caption = "Judgement";
                col.FieldName = "JUDGEMENT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "CreatedBy";
                col.Caption = "Created By";
                col.FieldName = "CREATED_BY";
                col.Width = Unit.Pixel(80);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "CreatedDate";
                col.Caption = "Created Date";
                col.FieldName = "CREATED_DT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
                
                col.ColumnType = MVCxGridViewColumnType.DateEdit;
                var deProperties = col.PropertiesEdit as DateEditProperties;
                deProperties.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "ChangedBy";
                col.Caption = "ChangedBy";
                col.FieldName = "CHANGED_BY";
                col.Width = Unit.Pixel(80);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "ChangedDate";
                col.Caption = "Changed Date";
                col.FieldName = "CHANGED_DT";
                col.Width = Unit.Pixel(60);
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                
                col.ColumnType = MVCxGridViewColumnType.DateEdit;
                var deProperties = col.PropertiesEdit as DateEditProperties;
                deProperties.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
            });
        
        
        ///set value for call from javascript
        Grv.CustomJSProperties = (s, e) =>
        {
            MVCxGridView grid = (MVCxGridView)s;
            
            //Changed By FID.Reggy
            int StartIndex = 0;
            //int StartIndex = grid.PageIndex * grid.SettingsPager.PageSize;
            int EndIndex = Model.GetModel<List<SPSafety>>() != null ? Model.GetModel<List<SPSafety>>().Count :
                           Math.Min(grid.VisibleRowCount, StartIndex + grid.SettingsPager.PageSize);
            //int EndIndex = Math.Min(grid.VisibleRowCount, StartIndex + grid.SettingsPager.PageSize);

            object[] ProductionMonth = new object[EndIndex - StartIndex];
            object[] SupplierCode = new object[EndIndex - StartIndex];
            object[] Fatal = new object[EndIndex - StartIndex];
            object[] Disability = new object[EndIndex - StartIndex];
            object[] LostOrgan = new object[EndIndex - StartIndex];
            object[] Absent = new object[EndIndex - StartIndex];
            object[] AbsentPeriode = new object[EndIndex - StartIndex];
            object[] SmallInjured = new object[EndIndex - StartIndex];
            object[] TotalWorkers = new object[EndIndex - StartIndex];
            object[] Judgement = new object[EndIndex - StartIndex];
            
            for (int i = StartIndex; i < EndIndex; i++)
            {
                ProductionMonth[i - StartIndex] = grid.GetRowValues(i, "PROD_MONTH");
                SupplierCode[i - StartIndex] = grid.GetRowValues(i, "SUPPLIER_CD");
                Fatal[i - StartIndex] = grid.GetRowValues(i, "QTY_FATAL");
                Disability[i - StartIndex] = grid.GetRowValues(i, "QTY_DISABILITY");
                LostOrgan[i - StartIndex] = grid.GetRowValues(i, "QTY_LOST_ORGAN");
                Absent[i - StartIndex] = grid.GetRowValues(i, "QTY_ABSENT");
                AbsentPeriode[i - StartIndex] = grid.GetRowValues(i, "QTY_ABSENT_PERIOD");
                SmallInjured[i - StartIndex] = grid.GetRowValues(i, "QTY_SMALL_INJURED");
                TotalWorkers[i - StartIndex] = grid.GetRowValues(i, "QTY_TOTAL_WORKERS_MH");
                Judgement[i - StartIndex] = grid.GetRowValues(i, "JUDGEMENT");
            }

            e.Properties["cpProductionMonth"] = ProductionMonth;
            e.Properties["cpSupplierCode"] = SupplierCode;
            e.Properties["cpFatal"] = Fatal;
            e.Properties["cpDisability"] = Disability;
            e.Properties["cpLostOrgan"] = LostOrgan;
            e.Properties["cpAbsent"] = Absent;
            e.Properties["cpAbsentPeriode"] = AbsentPeriode;
            e.Properties["cpSmallInjured"] = SmallInjured;
            e.Properties["cpTotalWorkers"] = TotalWorkers;
            e.Properties["cpJudgement"] = Judgement;
            grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
        };

        ///set gridview when button on clicked
        Grv.CommandButtonInitialize = (object sender, ASPxGridViewCommandButtonEventArgs e) =>
        {
            string IsEditRow = Request.Params["IsEditRow"];
            MVCxGridView gv = (MVCxGridView)sender;

            ///set visibility filter row
            if (IsEditRow == "1" || IsEditRow == "2")
            {
                gv.Settings.ShowFilterRow = false;
                gv.Settings.ShowFilterRowMenu = false;
            }
            else
            {
                gv.Settings.ShowFilterRow = true;
                gv.Settings.ShowFilterRowMenu = true;
            }

            ///Disable checkbox when grid is editing
            if (e.ButtonType == ColumnCommandButtonType.SelectCheckbox)
            {
                if (IsEditRow == "1" || IsEditRow == "2")
                    e.Enabled = false;
            }

            ///hide default button update and cancel on gridview when row is editing
            if (e.ButtonType == ColumnCommandButtonType.Update)
                e.Visible = false;

            if (e.ButtonType == ColumnCommandButtonType.Cancel)
                e.Visible = false;
        };

        ///disabled field when grid is editing
        Grv.CellEditorInitialize = (object sender, ASPxGridViewEditorEventArgs e) =>
        {
            MVCxGridView gv = (MVCxGridView)sender;
            string IsEditRow = Request.Params["IsEditRow"];

            if (e.Column.FieldName == "PROD_MONTH")
            {
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }
            }

            if (e.Column.FieldName == "SUPPLIER_CD")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                } 

            if (e.Column.FieldName == "SUPPLIER_NAME")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CREATED_BY")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CREATED_DT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CHANGED_BY")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CHANGED_DT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }
            
            //add by alira.agi 2015-04-15
            if (e.Column.FieldName == "JUDGEMENT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }
        };
    }).Bind(Model.GetModel<List<SPSafety>>()).GetHtml()